#ifndef HOST_UTILS_H
#define HOST_UTILS_H

#include <libubus.h>
#include <linux/netlink.h>
#include <linux/rtnetlink.h>
#include <netlink/netlink.h>
#include <netlink/utils.h>
#include <netlink/route/rtnl.h>
#include <netlink/route/neighbour.h>
#include <netlink/route/addr.h>
#include <netlink/route/link.h>
#include <netlink/genl/ctrl.h>
#include <netlink/genl/genl.h>
#include <netlink/attr.h>


#define NLMSG_NEIGH 28
#define IFLIST_REPLY_BUFFER     8192

int host_get_neigh(struct nlmsghdr *nlh, char *dev, char *dest_addr, uint8_t *mac_addr);
int host_get_netlink_ip(uint8_t *mac_addr, char *ipv4_str, char *device);
int host_get_netlink_ip6(uint8_t *mac_addr, struct host_node *p);
uint8_t count_tlv_present_instream_unsafe(uint8_t *tlv_stream);
uint16_t get_tlv_packet_len(uint8_t *tlv_stream);
uint8_t get_tlv_packet_type(uint8_t *tlv_stream);
void _E1B(uint8_t **packet_ppointer, uint8_t *memory_pointer);
void _E2B(uint8_t **packet_ppointer, uint16_t *memory_pointer);
void _EnB(uint8_t **packet_ppointer,
		void *memory_pointer,
		uint32_t n);
int register_nlevents(struct topologyd_private *priv);
int host_get_neighbors(struct topologyd_private *priv);
void unregister_nlevents(void);
#endif
